#!/bin/sh
. /www/cgi-bin/functions.sh
. /www/cgi-bin/webupgrade.sh

eval "`/www/cgi-bin/proccgi $*`"

REBOOTERROR_INITIALIZING=9999
echo "$REBOOTERROR_INITIALIZING" > $REBOOT_ERROR_FILE

refreshed_page=${QUERY_STRING}
if [ "$FORM_image_error" = "1" ]; then
	refreshed_page="/cgi-bin/webupgrade_failure.html"
	rm -f $CGI_UPLOAD_TMP_FILE
elif [ "$FORM_upgrade_yes_no" = "0" ]; then
	refreshed_page="/cgi-bin/upgrade.html"
	rm -f $CGI_UPLOAD_TMP_FILE
fi

print_http_refresh "http://${HTTP_HOST}${refreshed_page}"

exec >&-

if [ "$FORM_upgrade_yes_no" = "1" ]; then
	file_name=$(cat $CGI_UPLOAD_TMP_FILE)
	OFFSET=$(/sbin/webupload $file_name)
	mv $file_name $IMPORT_FILE_NAME

	imginstall $IMPORT_FILE_NAME $OFFSET &

	# reboot
	sleep 3
	#echo "`cat $REBOOT_ERROR_FILE`" > /dev/console 
	WEBUPGRADE_STATUS=$(cat $REBOOT_ERROR_FILE)
	if [ $WEBUPGRADE_STATUS != $STATUS_CHKSUM_ERROR -a $WEBUPGRADE_STATUS != $STATUS_CHKINFO_ERROR ];then 
		y=0
	        while test $y -le 30
		do
			success=$(cat /tmp/fw_success)
			y=$(($y+1))
			if [ "$success" != "1" ]; then
				sleep 2
			else
				if [ "`/tmp/nvram get auth_reboot`" != "xxxx" ]; then
          /tmp/nvram set auth_reboot=1
				else
					/tmp/nvram unset auth_ip
          /tmp/nvram unset auth_reboot
				fi
				/tmp/nvram commit
				[ -f /tmp/reboot ] && /tmp/reboot || /sbin/reboot
				break;
			fi
		done
	fi
	rm -f $REBOOT_ERROR_FILE	
fi
