#!/bin/sh
. /www/cgi-bin/functions.sh
. /www/cgi-bin/webupgrade.sh

eval "`/www/cgi-bin/proccgi $*`"

REBOOTERROR_INITIALIZING=9999
echo "$REBOOTERROR_INITIALIZING" > $REBOOT_ERROR_FILE

refreshed_page=${QUERY_STRING}

if [ "$FORM_submit_flag" = "write_image" ];then
	refreshed_page="/cgi-bin/auto_upgrade_process.html"
else
	refreshed_page="/cgi-bin/info.html"
fi

print_http_refresh "http://${HTTP_HOST}${refreshed_page}"

exec >&-
if [ "$FORM_submit_flag" = "write_image" ];then
	status=0
	while [ $status -lt 9999 ]
	do
	status=`awk -F ":" '{print $2}' $WEBUPGRADE_STATUS_FILE `
	oc echo $status
	done

	#imginstall &
	imginstall $IMAGE_FILE 0 &
	
	sleep 3	
	WEBUPGRADE_STATUS=$(cat $REBOOT_ERROR_FILE)
	if [ $WEBUPGRADE_STATUS != $STATUS_CHKSUM_ERROR -a $WEBUPGRADE_STATUS != $STATUS_CHKINFO_ERROR ];then
		y=0
	        while test $y -le 30
		do
			success=$(cat /tmp/fw_success)
			y=$(($y+1))
			if [ "$success" != "1" ]; then
				sleep 2
			else
				if [ "`/tmp/nvram get auth_reboot`" != "xxxx" ]; then
          /tmp/nvram set auth_reboot=1
				else
					/tmp/nvram unset auth_ip
          /tmp/nvram unset auth_reboot
				fi
				/tmp/nvram commit
				[ -f /tmp/reboot ] && /tmp/reboot || /sbin/reboot
				break;
			fi
		done 
	fi	
elif [ "$FORM_submit_flag" = "cancel" ];then
	touch $WEBUPGRADE_CANCEL_TOUCH 
fi
rm -f $REBOOT_ERROR_FILE
