config_lan2() #$1: lan ip, $2:lan netmask, $3:lan dhcp mode, $4:dhcp ip start, $5:dhcp ip end,  $6:network_flag $7:ip_flag $8:network $9:dmz_ip $10:bs_trustedip $11:rip_version_select $12:ip_direction_select $13:device_name $14:network2_flag $15:lan_dhcpclientmode , if lan ip is not changed, and subnet is changed. #$16: FORM_ether_gateway , $17: FORM_DNSAssign, $18: FORM_ether_dnsaddr1 , $19: FORM_ether_dnsaddr2 			 
{
	router_disable=$($nvram get router_disable)
	endis_wl_radio=$($nvram get endis_wl_radio)
	wds_endis_fun=$($nvram get wds_endis_fun)
	wds_repeater_basic=$($nvram get wds_repeater_basic)
	
	$nvram set old_lan_ipaddr=$($nvram get lan_ipaddr)
	if [ $endis_wl_radio -eq 1 -a $wds_endis_fun -eq 1 -a $wds_repeater_basic -eq 0 ];then
		$nvram set repeater_ip=$1
	else
		if [ "${15}" != "1" ];then
			$nvram set lan_ipaddr=$1
		fi
	fi
	$nvram set old_lan_netmask=$($nvram get lan_netmask)
	$nvram set lan_netmask=$2
	if [ "$3" = "1" ];then
		$nvram set lan_dhcp=1
		$nvram set dhcp_start=$4
		$nvram set dhcp_end=$5
		$nvram set lan_proto="dhcp"
	else
		$nvram set lan_dhcp=0
		$nvram set lan_proto=""
	fi
	
	if [ "$6" = "1" ];then
		ip=`$nvram get lan_ipaddr | sed 's/\([0-9]*.[0-9]*.[0-9]*\).*/\1/'`

		# for port forward web setting change
	        for file in `nvram show | grep ^forwarding | cut -d "=" -f1`
        	do
			new_info=`nvram get $file | sed "s/[0-9]*\.[0-9]*\.[0-9]*/$ip/"`
        	     	$nvram set $file="$new_info"
	        done
		# for port forward iptables setting change
		for file in `nvram show | grep ^forward_port | cut -d "=" -f1`
	        do
		      new_info=`nvram get $file | sed "s/[0-9]*\.[0-9]*\.[0-9]*/$ip/"`
                      $nvram set $file="$new_info"
	        done
	        # for port triggering web setting change
	        for file in ` nvram show | grep ^triggering | cut -d "=" -f1`
	        do
        	        new_info=`nvram get $file | sed "s/[0-9]*\.[0-9]*\.[0-9]*/$ip/"`
                	$nvram set $file="$new_info"
	        done
		# for port triggering iptables setting change
	        for file in ` nvram show | grep ^autofw_port | cut -d "=" -f1`
	        do
              	  	new_info=`nvram get $file | sed "s/[0-9]*\.[0-9]*\.[0-9]*/$ip/"`
	                $nvram set $file="$new_info"
        	done
	        for file in `nvram show | grep ^reservation | cut -d "=" -f1`
        	do
                	new_info=`nvram get $file | sed "s/[0-9]*\.[0-9]*\.[0-9]*/$ip/"`
	                $nvram set $file="$new_info"
        	done
	        for file in `nvram show | grep ^block_services | cut -d "=" -f1`
        	do
                	new_info=`nvram get $file | sed "s/[0-9]*\.[0-9]*\.[0-9]*/$ip/"`
                	new_info=`echo $new_info | sed "s/-[0-9]*\.[0-9]*\.[0-9]*/-$ip/"`
	                $nvram set $file="$new_info"
        	done

		#sp=0;
		index=1;
		old_ip=`$nvram get old_lan_ipaddr | sed 's/\([0-9]*.[0-9]*.[0-9]*\).*/\1/'`
		for file in `nvram show | grep ^static_router | cut -d "=" -f1`
		do
			new_info=`nvram get $file | awk '{print$6}' | sed 's/\([0-9]*.[0-9]*.[0-9]*\).*/\1/'`
			if [ "$old_ip" = "$new_info" -a "$ip" != "$new_info" ]; then
				#new_static_route_index[$sp]=`nvram show | grep $(echo $file) | sed 's/static_router//' | cut -d "=" -f1`
				$nvram unset $file
				#let "sp += 1"
			else
				nvram set static_router$index="`nvram get $file`"
				if [ "static_router$index" != "$file" ]; then
					nvram unset $file
				fi
				#let "index += 1"
				index=$(($index+1))
			fi
		done

		$nvram set dmz_ipaddr="$9"
		$nvram set block_trustedip="${10}"
	elif [ "$7" = "1" ];then
		ip=`$nvram get lan_ipaddr | sed 's/\([0-9]*.[0-9]*.[0-9]*\).*/\1/'`
	        for file in `nvram show | grep ^reservation | cut -d "=" -f1`
        	do
                	new_info=`nvram get $file | sed "s/[0-9]*\.[0-9]*\.[0-9]*/$ip/"`
	                $nvram set $file="$new_info"
        	done
	fi
	if [ "x${11}" = "x" ];then
		$nvram set rip_ver=0
        	$nvram set rip_dir=0
	else
		$nvram set rip_ver=${11}
		$nvram set rip_dir=${12}
	fi

	if [ "${14}" = "1" ];then
		#rm -f /tmp/configs/forwarding*
		#rm -f /tmp/configs/triggering*
		#rm -f /tmp/configs/reservation*
		#rm -f /tmp/configs/block_services*

		reservation_set=$($nvram show | grep reservation | awk -F= '{print $1}'); for tmp in `echo $reservation_set`;do $nvram unset $tmp; done
		triggering_set=$($nvram show | grep triggering | awk -F= '{print $1}'); for tmp in `echo $triggering_set`;do $nvram unset $tmp; done
		forwarding_set=$($nvram show | grep forward | awk -F= '{print $1}'); for tmp in `echo $forwarding_set`;do 	$nvram unset $tmp; done
		$nvram unset wan_endis_dmz; $nvram unset dmz_ipaddr
		blocking_set=`($nvram show | grep block_ && $nvram show | grep _block && $nvram show | grep blk)|awk -F= '{print $1}'`; for tmp in `echo $blocking_set`;do $nvram unset $tmp; done
		/etc/rc.d/blk_svc.sh stop
	fi
	$nvram set wan_hostname="${13}"
	$nvram set forfirewall="lan_setup"
	
	$nvram set lan_dhcpclient="${15}"

	if [ "${16}" = "0.0.0.0" ];then
		$nvram unset wan_gateway
	else
		$nvram set wan_gateway=${16}
	fi
#	echo "#########Jenny: do sh2 gatway=>$($nvram get wan_gateway)  #########" > /dev/console
	$nvram set wan_ether_dns_assign="${17}"
	$nvram set wan_ether_dns1=${18}
#	echo "#########Jenny: do sh2 dns1=>$($nvram get wan_ether_dns1)  #########" > /dev/console
	$nvram set wan_ether_dns2=${19}
	
	if [ "${17}" = "1" ];then
		$nvram set wan_autodns=0
		$nvram set wan_dns="${18} ${19}"
	else
		$nvram set wan_autodns=1
		$nvram set wan_dns=""
	fi
	
	$nvram commit
}
