function OnFieldChange(cf)
{
	var index = cf.plc_rule_field.selectedIndex;
	if ((index == 0)||(index == 1)) // EthDA, EthSA
	{
		cf.plc_rule_value.maxLength="17";
		cf.plc_rule_value.size="20";
		cf.plc_rule_value.value="";
	}
	else if((index == 2)||(index == 4)||(index == 5)||(index == 8)) // VLANUP, IPv4TOS, IPv4PROT, IPv6TC
	{
		cf.plc_rule_value.maxLength="3";
		cf.plc_rule_value.size="4";
		cf.plc_rule_value.value="";
	}	
	else if(index == 3) // VLANID
	{
		cf.plc_rule_value.maxLength="5";
		cf.plc_rule_value.size="6";
		cf.plc_rule_value.value="";
	}
	else if(index == 18) // ET
	{
		cf.plc_rule_value.maxLength="4";
		cf.plc_rule_value.size="5";
		cf.plc_rule_value.value="";
	}	
	else if((index == 6)||(index == 7)) // IPv4SA, IPv4DA
	{
		cf.plc_rule_value.maxLength="15";
		cf.plc_rule_value.size="16";
		cf.plc_rule_value.value="";
	}
	else if(index == 9) // IPv6FL
	{
		cf.plc_rule_value.maxLength="8";
		cf.plc_rule_value.size="9";
		cf.plc_rule_value.value="";
	}	
	else if(index == 19) // MME
	{
		cf.plc_rule_value.maxLength="6";
		cf.plc_rule_value.size="7";
		cf.plc_rule_value.value="";
	}
	else if((index == 10)||(index == 11)) // IPv6SA, IPv6SDA
	{
		cf.plc_rule_value.maxLength="39";
		cf.plc_rule_value.size="40";
		cf.plc_rule_value.value="";
	}
	else if((index == 12)||(index == 13)||(index == 14)||(index == 15)||(index == 16)||(index == 17)) // TCPSP, TCPDP, UDPSP, UDPDP, IPSP, IPDP
	{
		cf.plc_rule_value.maxLength="5";
		cf.plc_rule_value.size="6";
		cf.plc_rule_value.value="";
	}					
}

function getplcvalkey(cf,e)
{
	var keyCode;
	var field = cf.plc_rule_field.value;
	if (window.event) keycode = window.event.keyCode;
	else if (e) keycode = e.which;
	else return true;
    		
	if((field == "EthDA")||(field == "EthSA")||(field == "IPv6SA") || (field == "IPv6DA"))
	{
		if (((keycode>47) && (keycode<58))||((keycode>64) && (keycode<71))||((keycode>96) && (keycode<103))||(keycode == 8)||(keycode == 0) || (keycode == 58) || (keycode == 45))
                        return true;
                else return false;
	}
	else if((field == "MME") || (field == "ET"))
	{
		if (((keycode>47) && (keycode<58))||((keycode>64) && (keycode<71))||((keycode>96) && (keycode<103))||(keycode == 8)||(keycode == 0))
                        return true;
                else return false;
	}
	else if((field == "IPv4SA")||(field == "IPv4DA"))
	{
		if (((keycode>47) && (keycode<58))||(keycode == 8)||(keycode == 0)||(keycode == 46))
                        return true;
                else return false;
	}
	else if((field == "VLANUP")||(field == "VLANID")||(field == "IPv4TOS")||(field == "IPv4PROT")||(field == "IPv6TC")||(field == "IPv6FL") || (field == "TCPSP")||(field == "TCPDP")||(field == "UDPSP")||(field == "UDPDP")||(field == "IPSP")||(field == "IPDP"))
	{
		if (((keycode>47) && (keycode<58))||(keycode == 8)||(keycode == 0))
                        return true;
                else return false;
	}		
	else	
		return true;
}
function OnDeviceChange(cf)
{
	/*if (cf.rule_device.selectedIndex == 2)
	{  
	        cf.device.disabled = false;
	        if (cf.plc_rule_device.value.length >= 12)
	        	cf.device.value = cf.plc_rule_device.value;
	}
	else
	{
		if (cf.device.value.length >= 12)
			cf.plc_rule_device.value = cf.device.value;
	        cf.device.disabled = true;
	        cf.device.value="";
	}*/
}

function check_plcrule_add(cf,flag)
{
	if( array_num == 64 )
	{
		alert(plcrule_length_64);
		return false;
	}
	if(cf.plc_rule_value.value=="")
    	{
        	alert(plc_field_value_null);
        	return false;
    	}
    	
	/*if (cf.rule_device.selectedIndex != 2) // all or local
	{  
	        cf.plc_rule_device.value=cf.rule_device.value;
	}
	else
	{
		cf.plc_rule_device.value=cf.device.value;
		if(cf.plc_rule_device.value=="")
    		{
        		alert(plc_device_mac_null);
        		return false;
    		}
		the_mac=cf.plc_rule_device.value;
		if(the_mac.indexOf(":")==-1 && the_mac.length=="12")
		{
            		var tmp_mac=the_mac.substr(0,2)+":"+the_mac.substr(2,2)+":"+the_mac.substr(4,2)+":"+the_mac.substr(6,2)+":"+the_mac.substr(8,2)+":"+the_mac.substr(10,2);
			cf.plc_rule_device.value = tmp_mac;
        	}
		else if ( the_mac.split("-").length == 6 )
		{
			var tmp_mac = the_mac.replace(/-/g,":");
			cf.plc_rule_device.value=tmp_mac;
		}		
		if(maccheck(cf.plc_rule_device.value) == false)
			return false;
	}*/
		
	for(i=1;i<=array_num;i++)
    	{
		var str = eval ( 'plcRuleArray' + i );
		var each_info=str.split(' ');
		if (flag == 'add')
		{		
        		if((cf.plc_rule_action.value == each_info[0]) &&
			   (cf.plc_rule_operand.value == each_info[1]) &&
			   (cf.plc_rule_field.value == each_info[2]) &&
			   (cf.plc_rule_operator.value == each_info[3]) &&
			   (cf.plc_rule_value.value == each_info[4]) &&
			   (cf.plc_rule_control.value = each_info[5]) &&
			   (cf.plc_rule_volatility.value = each_info[6]) &&
			   (cf.plc_rule_device.value = each_info[7]))	
        		{
            			alert(plc_rule_dup);
            			return false;
        		}
        		if((cf.plc_rule_field.value == each_info[2])&&((each_info[2] == "VLANUP")||(each_info[2] == "VLANID")))	
        		{
            			alert(plc_rule_dup);
            			return false;
        		}
		}
		else
		{
			if( i != select_edit )
	        	{
        			if((cf.plc_rule_action.value == each_info[0]) &&
			   	(cf.plc_rule_operand.value == each_info[1]) &&
			   	(cf.plc_rule_field.value == each_info[2]) &&
			   	(cf.plc_rule_operator.value == each_info[3]) &&
			   	(cf.plc_rule_value.value == each_info[4]) &&
			   	(cf.plc_rule_control.value = each_info[5]) &&
			   	(cf.plc_rule_volatility.value = each_info[6]) &&
			   	(cf.plc_rule_device.value = each_info[7]))	
        			{
            				alert(plc_rule_dup);
            				return false;
        			}
        			if((cf.plc_rule_field.value == each_info[2])&&((each_info[2] == "VLANUP")||(each_info[2] == "VLANID")))	
        			{
            				alert(plc_rule_dup);
            				return false;
        			}        			
			}
		}
    	}
    	
	var index = cf.plc_rule_field.selectedIndex;
	if ((index == 0)||(index == 1)) // EthDA, EthSA
	{
		the_mac=cf.plc_rule_value.value;
		if(the_mac.indexOf(":")==-1 && the_mac.length=="12")
		{
            		var tmp_mac=the_mac.substr(0,2)+":"+the_mac.substr(2,2)+":"+the_mac.substr(4,2)+":"+the_mac.substr(6,2)+":"+the_mac.substr(8,2)+":"+the_mac.substr(10,2);
			cf.plc_rule_value.value = tmp_mac;
        	}
		else if ( the_mac.split("-").length == 6 )
		{
			var tmp_mac = the_mac.replace(/-/g,":");
			cf.plc_rule_value.value=tmp_mac;
		}		
		if(maccheck(cf.plc_rule_value.value) == false)
			return false;
	}
	else if((index == 2)||(index == 4)||(index == 5)||(index == 8)) // VLANUP, IPv4TOS, IPv4PROT, IPv6TC
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>255))
		{
			alert(invalid_plc_qos_value_range255);
			return false;
		}
	}	
	else if(index == 3) // VLANID
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>65535))
		{
			alert(invalid_plc_qos_value_range65535);
			return false;
		}
	}
	else if(index == 18) // ET
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>65535))
		{
			alert(invalid_plc_qos_value_range65535);
			return false;
		}
	}	
	else if((index == 6)||(index == 7)) // IPv4SA, IPv4DA
	{
		the_ip=cf.plc_rule_value.value;
		if ( the_ip.split(".").length != 4 )
		{
			alert(invalid_ip);
			return false;
		}
		if( checkipaddr(cf.plc_rule_value.value)== false )
		{	
			alert(invalid_ip);
			return false;
		}
	}
	else if(index == 9) // IPv6FL
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>16777215))
		{
			alert(invalid_plc_qos_value_range16777215);
			return false;
		}
	}	
	else if(index == 19) // MME
	{
		var a;
	}
	else if((index == 10)||(index == 11)) // IPv6SA, IPv6SDA
	{
		the_ip=cf.plc_rule_value.value;
		if ( the_ip.split(":").length != 8 )
		{
			alert(invalid_ip);
			return false;
		}		
	}
	else if((index == 12)||(index == 13)||(index == 14)||(index == 15)||(index == 16)||(index == 17)) // TCPSP, TCPDP, UDPSP, UDPDP, IPSP, IPDP
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>65535))
		{
			alert(invalid_plc_qos_value_range65535);
			return false;
		}
	}

	return true;
}

function check_plcrule_edit(cf,flag)
{
	if(cf.plc_rule_value.value=="")
    	{
        	alert(plc_field_value_null);
        	return false;
    	}
    	
	/*if (cf.rule_device.selectedIndex != 2) // all or local
	{  
	        cf.plc_rule_device.value=cf.rule_device.value;
	}
	else
	{
		cf.plc_rule_device.value=cf.device.value;
		if(cf.plc_rule_device.value=="")
    		{
        		alert(plc_device_mac_null);
        		return false;
    		}
		the_mac=cf.plc_rule_device.value;
		if(the_mac.indexOf(":")==-1 && the_mac.length=="12")
		{
            		var tmp_mac=the_mac.substr(0,2)+":"+the_mac.substr(2,2)+":"+the_mac.substr(4,2)+":"+the_mac.substr(6,2)+":"+the_mac.substr(8,2)+":"+the_mac.substr(10,2);
			cf.plc_rule_device.value = tmp_mac;
        	}
		else if ( the_mac.split("-").length == 6 )
		{
			var tmp_mac = the_mac.replace(/-/g,":");
			cf.plc_rule_device.value=tmp_mac;
		}		
		if(maccheck(cf.plc_rule_device.value) == false)
			return false;
	}*/	
    	
    	for(i=1;i<=array_num;i++)
    	{
        	var str = eval ( 'plcRuleArray' + i );
        	var each_info=str.split(' ');
        	if (flag == 'add')
        	{
        		if((cf.plc_rule_action.value == each_info[0]) &&
			   (cf.plc_rule_operand.value == each_info[1]) &&
			   (cf.plc_rule_field.value == each_info[2]) &&
			   (cf.plc_rule_operator.value == each_info[3]) &&
			   (cf.plc_rule_value.value == each_info[4]) &&
			   (cf.plc_rule_control.value = each_info[5]) &&
			   (cf.plc_rule_volatility.value = each_info[6]) &&
			   (cf.plc_rule_device.value = each_info[7]))	
        		{
            			alert(plc_rule_dup);
            			return false;
        		}
        		if((cf.plc_rule_field.value == each_info[2])&&((each_info[2] == "VLANUP")||(each_info[2] == "VLANID")))
        		{
            			alert(plc_rule_dup);
            			return false;
        		}          		
        	}
        	else
        	{
			if( i != select_edit )
	        	{
        			if((cf.plc_rule_action.value == each_info[0]) &&
			   	(cf.plc_rule_operand.value == each_info[1]) &&
			   	(cf.plc_rule_field.value == each_info[2]) &&
			   	(cf.plc_rule_operator.value == each_info[3]) &&
			   	(cf.plc_rule_value.value == each_info[4]) &&
			   	(cf.plc_rule_control.value = each_info[5]) &&
			   	(cf.plc_rule_volatility.value = each_info[6]) &&
			   	(cf.plc_rule_device.value = each_info[7]))	
        			{
            				alert(plc_rule_dup);
            				return false;
        			}
        			if((cf.plc_rule_field.value == each_info[2])&&((each_info[2] == "VLANUP")||(each_info[2] == "VLANID")))	
        			{
            				alert(plc_rule_dup);
            				return false;
        			}          			
			}            		
        	}
    	}
    	
	var index = cf.plc_rule_field.selectedIndex;
	if ((index == 0)||(index == 1)) // EthDA, EthSA
	{
		the_mac=cf.plc_rule_value.value;
		if(the_mac.indexOf(":")==-1 && the_mac.length=="12")
		{
            		var tmp_mac=the_mac.substr(0,2)+":"+the_mac.substr(2,2)+":"+the_mac.substr(4,2)+":"+the_mac.substr(6,2)+":"+the_mac.substr(8,2)+":"+the_mac.substr(10,2);
			cf.plc_rule_value.value = tmp_mac;
        	}
		else if ( the_mac.split("-").length == 6 )
		{
			var tmp_mac = the_mac.replace(/-/g,":");
			cf.plc_rule_value.value=tmp_mac;
		}		
		if(maccheck(cf.plc_rule_value.value) == false)
			return false;
	}
	else if((index == 2)||(index == 4)||(index == 5)||(index == 8)) // VLANUP, IPv4TOS, IPv4PROT, IPv6TC
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>255))
		{
			alert(invalid_plc_qos_value_range255);
			return false;
		}
	}	
	else if(index == 3) // VLANID
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>65535))
		{
			alert(invalid_plc_qos_value_range65535);
			return false;
		}
	}
	else if(index == 18) // ET
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>65535))
		{
			alert(invalid_plc_qos_value_range65535);
			return false;
		}
	}	
	else if((index == 6)||(index == 7)) // IPv4SA, IPv4DA
	{
		the_ip=cf.plc_rule_value.value;
		if ( the_ip.split(".").length != 4 )
		{
			alert(invalid_ip);
			return false;
		}
		if( checkipaddr(cf.plc_rule_value.value)== false )
		{	
			alert(invalid_ip);
			return false;
		}
	}
	else if(index == 9) // IPv6FL
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>16777215))
		{
			alert(invalid_plc_qos_value_range16777215);
			return false;
		}
	}	
	else if(index == 19) // MME
	{
		var a;
	}
	else if((index == 10)||(index == 11)) // IPv6SA, IPv6SDA
	{
		the_ip=cf.plc_rule_value.value;
		if ( the_ip.split(":").length != 8 )
		{
			alert(invalid_ip);
			return false;
		}
	}
	else if((index == 12)||(index == 13)||(index == 14)||(index == 15)||(index == 16)||(index == 17)) // TCPSP, TCPDP, UDPSP, UDPDP, IPSP, IPDP
	{
		if ((cf.plc_rule_value.value<0)||(cf.plc_rule_value.value>65535))
		{
			alert(invalid_plc_qos_value_range65535);
			return false;
		}
	}

    return true;
}

function check_plcrule_editnum(cf)
{
	if( array_num == "" )
	{
		alert(plc_no_serv_edit);
		return false;
	}
	var count_select=0;
	var select_num;
	if( array_num == 1)
	{
		if(cf.select_plcrule.checked == true)
		{
			count_select++;
			select_num=1;
		}
	}
	else for(i=0;i<array_num;i++)
		if(cf.select_plcrule[i].checked == true)
		{
			count_select++;
			select_num=i+1;
		}
	if(count_select==0)
	{
		alert(plc_select_serv_edit);
		return false;
	}
	else
	{
		cf.select_edit.value=select_num;
		cf.submit_flag.value="plcrule_editnum";
		cf.action="/cgi-bin/setobject.cgi?/cgi-bin/plcrule_edit.html";
		return true;
	}
}

function check_plcrule_del(cf)
{
	if( array_num == "" )
	{
		alert(plc_no_serv_del);
		return false;
	}
	var count_select=0;
	var select_num;
	if( array_num == 1)
	{
		if(cf.select_plcrule.checked == true)
		{
			count_select++;
			select_num=1;
		}
	}
	else
	{
		for(i=0;i<array_num;i++)
		{
			if(cf.select_plcrule[i].checked == true)
			{
				count_select++;
				select_num=i+1;
			}
		}
	}
	if(count_select==0)
	{
		alert(plc_select_serv_del);
		return false;
	}
	else
	{
		cf.select_del.value=select_num;
		cf.submit_flag.value="plcrule_del";
		cf.action="/cgi-bin/setobject.cgi?/cgi-bin/plcrulelist.html";
		return true;
	}
}

function check_plcrule_apply(cf)
{
	if( cf.accessLimit.checked == true )
		cf.plc_rule_ctrl_on.value=1;
	else
		cf.plc_rule_ctrl_on.value=0;
		cf.submit_flag.value="plcrule_apply";
		cf.action="/cgi-bin/setobject.cgi?/cgi-bin/plcrulelist.html";
	return true;
}

function qos_rule_data_select(num)
{
	var cf = document.forms[0];
	var str = eval ( 'plcRuleArray' + num );
	var each_info=str.split(' ');
	
	cf.plc_rule_action.value = each_info[0];
	cf.plc_rule_operand.value = each_info[1];
	cf.plc_rule_field.value = each_info[2];
	cf.plc_rule_operator.value = each_info[3];
	cf.plc_rule_value.value = each_info[4];
	cf.plc_rule_control.value = each_info[5];
	cf.plc_rule_volatility.value = each_info[6];
	cf.plc_rule_device.value = each_info[7];	
}
