#!/bin/sh
. /www/cgi-bin/functions.sh
eval "`/www/cgi-bin/proccgi $*`"
refreshed_page="/cgi-bin/restore_process.html"
print_http_refresh "http://${HTTP_HOST}${refreshed_page}"

echo "0" >  /tmp/restore_status

exec >&-

OFFSET=$(/sbin/webupload $CGI_POST_TMPFILE)
echo $OFFSET > /tmp/offset
echo "     offset= " $OFFSET 
#lockfile /tmp/config-mtd.lock
cd /tmp
if dd if=$CGI_POST_TMPFILE of=/tmp/AABBCCXXYY bs=1 skip=$OFFSET >/dev/null 2>&1 ; then
	echo "1" >  /tmp/restore_status
	rm -rf $CGI_POST_TMPFILE
	getstatus=0
else
	echo "2" >  /tmp/restore_status
	rm -rf $CGI_POST_TMPFILE /tmp/AABBCCXXYY
	getstatus=1
fi

mv /tmp/tc_pot /tmp/tc_pot_bak

if [ "$getstatus" = "0" ]; then
	module=$(dd if=/tmp/AABBCCXXYY bs=1 count=128 2>/dev/null | grep device | sed "s/device://")
	DEVICE=$(cat /module_name)
	if [ "$module" = "NETGEAR_$DEVICE.cfg" ]; then
		echo "3" >  /tmp/restore_status
		infostatus=0
	else
		echo "4" >  /tmp/restore_status
		rm -rf /tmp/AABBCCXXYY
		infostatus=1
	fi
	
	region=$(dd if=/tmp/AABBCCXXYY bs=1 count=128 2>/dev/null | grep region | sed "s/region://")
	MODULE_REGION=$(cat /tmp/region-setted)
	if [ "$region" != "$MODULE_REGION" ]; then
		echo "6" >  /tmp/restore_status
		rm -rf /tmp/AABBCCXXYY
		infostatus=1
	fi
fi

if [ "$infostatus" = "0" ]; then
	if /sbin/mychecksum -i /tmp/AABBCCXXYY > /dev/null 2>&1 ; then
		echo "5" >  /tmp/restore_status
		ApCfgLength=$(dd if=/tmp/AABBCCXXYY bs=1 count=128 2>/dev/null | grep ApCfg | sed "s/ApCfg://")
		PlcCfgLength=$(dd if=/tmp/AABBCCXXYY bs=1 count=128 2>/dev/null | grep PlcCfg | sed "s/PlcCfg://")
		PlcFwVer=$(dd if=/tmp/AABBCCXXYY bs=1 count=128 2>/dev/null | grep PlcVer | sed "s/PlcVer://")
		PlcCfgOffset=$(($ApCfgLength+128))
		dd if=/tmp/AABBCCXXYY of=/tmp/ui_plc.pib bs=1 skip=$PlcCfgOffset count=$PlcCfgLength 2>/dev/null		
		dd if=/tmp/AABBCCXXYY of=/tmp/nvram.config bs=1 skip=128 count=$ApCfgLength 2>/dev/null
		rm -rf /tmp/AABBCCXXYY
		rm -rf /tmp/configs/nvram.config
		#echo "           ########### decrypting ############ " >  /dev/console
		/sbin/encrypt -i /tmp/nvram.config
		cp /tmp/nvram.config /tmp/configs/nvram.config
		/usr/sbin/mtdcmd commit "$PlcFwVer" "/tmp/ui_plc.pib"
		checkstatus=0
	else
		echo "6" >  /tmp/restore_status
		rm -rf /tmp/AABBCCXXYY
		checkstatus=1
	fi
fi

[ ! -d /tmp/tc_pot ] && mkdir /tmp/tc_pot
mv /tmp/tc_pot_bak/* /tmp/tc_pot/
rm -fr /tmp/tc_pot_bak

if [ "$checkstatus" = "0" ]; then
	echo "7" >  /tmp/restore_status
	#echo "             ####### nvram commit ##############  " >  /dev/console
	#/usr/sbin/nvram commit
fi	
